明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1303|回复: 3

请教各位高手一个简单的问题

[复制链接]
发表于 2003-11-2 11:24:00 | 显示全部楼层 |阅读模式
我想对某个图层中的对象进行操作
运行for each ent in thisdrawing.layer(i)时提示出错 对象不对
请问我该如何更改呢?
谢先
发表于 2003-11-2 11:50:00 | 显示全部楼层
图层中是没有对象的。
你必须使用带过滤器的选择集来选择指定图层下的对象,然后再对这些对象进行操作。
发表于 2003-11-2 11:52:00 | 显示全部楼层
这是一个转换对象图层的程序,你看看吧:
  1. Sub ChgLayer()
  2.     On Error Resume Next
  3.     Dim Ent As AcadEntity
  4.     Dim Pnt As Variant
  5.     ThisDrawing.Utility.GetEntity Ent, Pnt, vbCrLf & "选择所要改变图层的对象:"
  6.    
  7.     Dim LayName As String
  8.     LayName = Ent.Layer
  9.     ThisDrawing.Utility.Prompt vbCrLf & "你选择转换的图层名称是" & LayName
  10.     Dim NewLayerName As String
  11.     Dim lay As AcadLayer
  12.     Do
  13.         NewLayerName = ThisDrawing.Utility.GetString(0, vbCrLf & "输入要转换到的图层名:")
  14.         Set lay = ThisDrawing.Layers(NewLayerName)
  15.         If Err Then
  16.             Err.Clear
  17.             ThisDrawing.Utility.Prompt vbCrLf & "该名称的图层不存在,请重新输入"
  18.         Else
  19.             Exit Do
  20.         End If
  21.     Loop
  22.     Dim FType(0) As Integer
  23.     Dim FData(0) As Variant
  24.     FType(0) = 8
  25.     FData(0) = LayName
  26.     Dim ss As AcadSelectionSet
  27.     Set ss = CreatSSet
  28.     ss.Select acSelectionSetAll, , , FType, FData
  29.     Dim i As Integer
  30.     For i = 0 To ss.Count - 1
  31.         ss(i).Layer = NewLayerName
  32.     Next i
  33.    
  34. End Sub

  35. Function CreatSSet()
  36.     Dim ss As AcadSelectionSet
  37.     On Error Resume Next
  38.     Set ss = ThisDrawing.SelectionSets.Add("mccad")
  39.     If Err Then
  40.         Err.Clear
  41.         Set ss = ThisDrawing.SelectionSets("mccad")
  42.         ss.Clear
  43.     End If
  44.     Set CreatSSet = ss
  45. End Function
 楼主| 发表于 2003-11-2 19:48:00 | 显示全部楼层
谢谢斑竹
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-28 12:54 , Processed in 0.599352 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表